//+------------------------------------------------------------------+
//|                                                     COL4PAIR.mq4 |
//|                        Copyright 2014, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//|                                                           EL.mq4 |
//|                        Copyright 2013, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//|                                                 All_usd_pair.mq4 |
//|                                                            kukan |
//|                                                     www.kukan.ru |
//+------------------------------------------------------------------+
#property copyright "kukan"
#property link      "www.kukan.ru"
//----
#property indicator_chart_window
#property indicator_buffers 8
#property indicator_color1 Yellow
#property indicator_color2 OrangeRed
#property indicator_color3 PaleGreen
#property indicator_color4 Blue
#property indicator_color5 ForestGreen
#property indicator_color6 Tan
#property indicator_color7 SpringGreen
#property indicator_color8 Aqua
//---- buffers
extern   int      line_centre=400;  //?????????? ??????????? ?????
extern   int      dir_EurUsd=1;  //????? ?????????? ????? 1 ?????? 0 ????????
extern   int      dir_AudUsd=1;
extern   int      dir_EurGbp=1;
extern   int      dir_GbpUsd=1;  //?? ????????? ? ??????? ?????????
extern   int      dir_EurAud=1;
extern   int      dir_UsdChf=1;
extern   int      dir_GbpAud=1;
extern   int      dir_AudChf=1;
//----
int   ia,ib,ic,id,ie=0;
int   cnt1,cnt2,temp0,temp1=0;
double   centre_EurUsd,centre_AudUsd,centre_EurGbp,centre_GbpUsd,centre_EurAud,centre_UsdChf,centre_GbpAud,centre_AudChf;
double   centre_curent;
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];
double ExtMapBuffer5[];
double ExtMapBuffer6[];
double ExtMapBuffer7[];
double ExtMapBuffer8[];
double EurUsd[],AudUsd[],EurGbp[],GbpUsd[],EurAud[],UsdChf[],GbpAud[],AudChf[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(2,ExtMapBuffer3);
   SetIndexStyle(3,DRAW_LINE);
   SetIndexBuffer(3,ExtMapBuffer4);
   SetIndexStyle(4,DRAW_LINE);
   SetIndexBuffer(4,ExtMapBuffer5);
   SetIndexStyle(5,DRAW_LINE);
   SetIndexBuffer(5,ExtMapBuffer6);
   SetIndexStyle(6,DRAW_LINE);
   SetIndexBuffer(6,ExtMapBuffer7);
   SetIndexStyle(7,DRAW_LINE);
   SetIndexBuffer(7,ExtMapBuffer8);
//----
   ArrayInitialize(ExtMapBuffer1,EMPTY_VALUE);
   ArrayInitialize(ExtMapBuffer2,EMPTY_VALUE);
   ArrayInitialize(ExtMapBuffer3,EMPTY_VALUE);
   ArrayInitialize(ExtMapBuffer4,EMPTY_VALUE);
   ArrayInitialize(ExtMapBuffer5,EMPTY_VALUE);
   ArrayInitialize(ExtMapBuffer6,EMPTY_VALUE);
   ArrayInitialize(ExtMapBuffer7,EMPTY_VALUE);
   ArrayInitialize(ExtMapBuffer8,EMPTY_VALUE);
   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 
   ObjectDelete("EurUsd");
   ObjectDelete("AudUsd");
   ObjectDelete("EurGbp");
   ObjectDelete("GbpUsd");
   ObjectDelete("EurAud");
   ObjectDelete("UsdChf");
   ObjectDelete("GbpAud");
   ObjectDelete("AudChf");
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted();
//---- 
   ArrayCopySeries(EurUsd,MODE_CLOSE,"EURUSD",Period());
   ArrayCopySeries(AudUsd,MODE_CLOSE,"AUDUSD",Period());
   ArrayCopySeries(EurGbp,MODE_CLOSE,"EURGBP",Period());
   ArrayCopySeries(GbpUsd,MODE_CLOSE,"GBPUSD",Period());
   ArrayCopySeries(EurAud,MODE_CLOSE,"EURAUD",Period());
   ArrayCopySeries(UsdChf,MODE_CLOSE,"USDCHF",Period());
   ArrayCopySeries(GbpAud,MODE_CLOSE,"GBPAUD",Period());
   ArrayCopySeries(AudChf,MODE_CLOSE,"AUDCHF",Period());
   //??????? ?????? ??????????? ???????
   temp0=Bars-1;
   if (ArraySize(EurUsd)<temp0+1)  {temp0=ArraySize(EurUsd)-1;Comment("???? ?????? ?? EurUsd "+Period()+" "+ArraySize(EurUsd));}
   if (ArraySize(AudUsd)<temp0+1)  {temp0=ArraySize(AudUsd)-1;Comment("???? ?????? ?? AudUsd "+Period()+" "+ArraySize(AudUsd));}
   if (ArraySize(EurGbp)<temp0+1)  {temp0=ArraySize(EurGbp)-1;Comment("???? ?????? ?? EurGbp "+Period()+" "+ArraySize(EurGbp));}
   if (ArraySize(GbpUsd)<temp0+1)  {temp0=ArraySize(GbpUsd)-1;Comment("???? ?????? ?? GbpUsd "+Period()+" "+ArraySize(GbpUsd));}
   if (ArraySize(EurAud)<temp0+1)  {temp0=ArraySize(EurAud)-1;Comment("???? ?????? ?? EurAud "+Period()+" "+ArraySize(EurAud));}
   if (ArraySize(UsdChf)<temp0+1)  {temp0=ArraySize(UsdChf)-1;Comment("???? ?????? ?? UsdCad "+Period()+" "+ArraySize(UsdChf));}
   if (ArraySize(GbpAud)<temp0+1)  {temp0=ArraySize(GbpAud)-1;Comment("???? ?????? ?? GbpAud "+Period()+" "+ArraySize(GbpAud));}
   if (ArraySize(AudChf)<temp0+1)  {temp0=ArraySize(AudChf)-1;Comment("???? ?????? ?? AudChf "+Period()+" "+ArraySize(AudChf));}
   //???? ?? ??????? ????? ?????? ??? ????? ??????????, ?? ?????
     if (line_centre>=temp0) 
     {
      Comment("????????? ?????? ? ???????.... ");
      return(0);
     }
   //??????? ??????? ???????
   if (temp0-line_centre<Bars-counted_bars)  temp1=temp0-line_centre;
   else  temp1=Bars-counted_bars;
     for(ia=temp1;ia>=0;ia--) 
     {
      //????????? ??????? ???????? ?????
      centre_EurUsd=0;
      centre_AudUsd=0;
      centre_EurGbp=0;
      centre_GbpUsd=0;
      centre_EurAud=0;
      centre_UsdChf=0;
      centre_GbpAud=0;
      centre_AudChf=0;
      centre_curent=0;
        for(ic=line_centre-1;ic>=0;ic--) 
        {
         centre_EurUsd=centre_EurUsd+EurUsd[ia+ic];
         centre_AudUsd=centre_AudUsd+AudUsd[ia+ic];
         centre_EurGbp=centre_EurGbp+EurGbp[ia+ic];
         centre_GbpUsd=centre_GbpUsd+GbpUsd[ia+ic];
         centre_EurAud=centre_EurAud+EurAud[ia+ic];
         centre_UsdChf=centre_UsdChf+UsdChf[ia+ic];
         centre_GbpAud=centre_GbpAud+GbpAud[ia+ic];
         centre_AudChf=centre_AudChf+AudChf[ia+ic];
         centre_curent=centre_curent+Close[ia+ic];
        }
      centre_EurUsd=centre_EurUsd/line_centre;
      centre_AudUsd=centre_AudUsd/line_centre;
      centre_EurGbp=centre_EurGbp/line_centre;
      centre_GbpUsd=centre_GbpUsd/line_centre;
      centre_EurAud=centre_EurAud/line_centre;
      centre_UsdChf=centre_UsdChf/line_centre;
      centre_GbpAud=centre_GbpAud/line_centre;
      centre_AudChf=centre_AudChf/line_centre;
      centre_curent=centre_curent/line_centre;
      //???????? ? ?????? ??????????? ?????, ?.?. ????????? ?????????? ?????????
      ExtMapBuffer1[ia]=
      (dir_EurUsd*EurUsd[ia]+(1-dir_EurUsd)/EurUsd[ia])*centre_curent/(dir_EurUsd*centre_EurUsd+(1-dir_EurUsd)/centre_EurUsd);
      ExtMapBuffer2[ia]=
      (dir_AudUsd*AudUsd[ia]+(1-dir_AudUsd)/AudUsd[ia])*centre_curent/(dir_AudUsd*centre_AudUsd+(1-dir_AudUsd)/centre_AudUsd);
      ExtMapBuffer3[ia]=
      (dir_EurGbp*EurGbp[ia]+(1-dir_EurGbp)/EurGbp[ia])*centre_curent/(dir_EurGbp*centre_EurGbp+(1-dir_EurGbp)/centre_EurGbp);
      ExtMapBuffer4[ia]=
      (dir_GbpUsd*GbpUsd[ia]+(1-dir_GbpUsd)/GbpUsd[ia])*centre_curent/(dir_GbpUsd*centre_GbpUsd+(1-dir_GbpUsd)/centre_GbpUsd);
      ExtMapBuffer5[ia]=
      (dir_EurAud*EurAud[ia]+(1-dir_EurAud)/EurAud[ia])*centre_curent/(dir_EurAud*centre_EurAud+(1-dir_EurAud)/centre_EurAud);
      ExtMapBuffer6[ia]=
      (dir_UsdChf*UsdChf[ia]+(1-dir_UsdChf)/UsdChf[ia])*centre_curent/(dir_UsdChf*centre_UsdChf+(1-dir_UsdChf)/centre_UsdChf);
      ExtMapBuffer7[ia]=
      (dir_GbpAud*GbpAud[ia]+(1-dir_GbpAud)/GbpAud[ia])*centre_curent/(dir_GbpAud*centre_GbpAud+(1-dir_GbpAud)/centre_GbpAud);
      ExtMapBuffer8[ia]=
      (dir_AudChf*AudChf[ia]+(1-dir_AudChf)/AudChf[ia])*centre_curent/(dir_AudChf*centre_AudChf+(1-dir_AudChf)/centre_AudChf);
/*
Comment("????????????? ????????? ???????? ??? "+Period()
   +"\nGBPUSD  -"+GbpUsd[0]
   +"\nUSDJPY  -"+UsdJpy[0]
   );
*/
        if ((Bars-counted_bars)==1)   
        {
         //???????????? ????????? ?????? ?????
         ObjectDelete("EurUsd");
         ObjectCreate("EurUsd",OBJ_TEXT,0,Time[0]+Period()*11*60,ExtMapBuffer1[0]);
         ObjectSet("EurUsd",OBJPROP_COLOR,Yellow);
         ObjectSetText("EurUsd","EurUsd "+DoubleToStr(EurUsd[0],4),8,"arial");
         //
         ObjectDelete("AudUsd");
         ObjectCreate("AudUsd",OBJ_TEXT,0,Time[0]+Period()*11*60,ExtMapBuffer2[0]);
         ObjectSet("AudUsd",OBJPROP_COLOR,OrangeRed);
         ObjectSetText("AudUsd","AudUsd "+DoubleToStr(AudUsd[0],4),8,"arial");
         //
         ObjectDelete("EurGbp");
         ObjectCreate("EurGbp",OBJ_TEXT,0,Time[0]+Period()*11*60,ExtMapBuffer3[0]);
         ObjectSet("EurGbp",OBJPROP_COLOR,PaleGreen);
         ObjectSetText("EurGbp","EurGbp "+DoubleToStr(EurGbp[0],4),8,"arial");
         //
         ObjectDelete("GbpUsd");
         ObjectCreate("GbpUsd",OBJ_TEXT,0,Time[0]+Period()*11*60,ExtMapBuffer4[0]);
         ObjectSet("GbpUsd",OBJPROP_COLOR,Blue);
         ObjectSetText("GbpUsd","GbpUsd "+DoubleToStr(GbpUsd[0],4),8,"arial");
         //
         ObjectDelete("EurAud");
         ObjectCreate("EurAud",OBJ_TEXT,0,Time[0]+Period()*11*60,ExtMapBuffer5[0]);
         ObjectSet("EurAud",OBJPROP_COLOR,ForestGreen);
         ObjectSetText("EurAud","EurAud "+DoubleToStr(EurAud[0],2),8,"arial");
         //
         ObjectDelete("UsdChf");
         ObjectCreate("UsdChf",OBJ_TEXT,0,Time[0]+Period()*11*60,ExtMapBuffer6[0]);
         ObjectSet("UsdChf",OBJPROP_COLOR,Tan);
         ObjectSetText("UsdChf","UsdChf "+DoubleToStr(UsdChf[0],4),8,"arial");

         ObjectDelete("GbpAud");
         ObjectCreate("GbpAud",OBJ_TEXT,0,Time[0]+Period()*11*60,ExtMapBuffer7[0]);
         ObjectSet("GbpAud",OBJPROP_COLOR,SpringGreen);
         ObjectSetText("GbpAud","GbpAud "+DoubleToStr(GbpAud[0],4),8,"arial");

         ObjectDelete("AudChf");
         ObjectCreate("AudChf",OBJ_TEXT,0,Time[0]+Period()*11*60,ExtMapBuffer8[0]);
         ObjectSet("AudChf",OBJPROP_COLOR,Aqua);
         ObjectSetText("AudChf","AudChf "+DoubleToStr(AudChf[0],4),8,"arial");
        }
     }
//----
   return(0);
  }
//+------------------------------------------------------------------+